unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button2: TButton;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  FLOPP_S=1457664;
var
  arr:array[1..FLOPP_S] of byte;

function HasOverlappedIoCompleted(OVR:TOverlapped):boolean;
begin
 Result:= OVR.Internal<>STATUS_PENDING
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  FileHandle,DestFileHandle:THandle;
  Overlap: TOverlapped;
  res:BOOL;
  _WRITED,i,LastError:DWORD;
begin
  FillChar(Overlap,SizeOf(Overlap),0);
  for i:=1 to trunc(FLOPP_S/100) do
   arr[i*100]:=ord('Q');
  FileHandle:=CreateFile('a:\file.dat',GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,0);
  if FileHandle=INVALID_HANDLE_VALUE then
   begin
    ShowMessage(' ');
    exit;
   end;
  Overlap.hEvent:=CreateEvent(0,True,False,0);
  res:=WriteFile(FileHandle,arr,FLOPP_S,_WRITED,@Overlap);
  LastError := GetLastError;
  ShowMessage(' ');

  if not res then
   begin
    if LastError = ERROR_IO_PENDING then
     while  not HasOverlappedIoCompleted(Overlap) do
       Application.ProcessMessages
                                    else
      ShowMessage(' ');
   end;
  GetOverlappedResult(FileHandle,Overlap,_WRITED,FALSE);
  ShowMessage(' !   '+IntToStr(_WRITED));
  CloseHandle(Overlap.hEvent);
  CloseHandle(FileHandle);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FileHandle,DestFileHandle:THandle;
  Overlap: TOverlapped;
  res:BOOL;
  _WRITED,i,LastError:DWORD;
begin
  FillChar(Overlap,SizeOf(Overlap),0);
  for i:=1 to trunc(FLOPP_S/100) do
   arr[i*100]:=ord('Q');
  FileHandle:=CreateFile('a:\file.dat',GENERIC_WRITE ,0,0,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,0);
  if FileHandle=INVALID_HANDLE_VALUE then
   begin
    ShowMessage(' ');
    exit;
   end;
  Overlap.hEvent:=CreateEvent(0,True,False,0);
  res:=WriteFile(FileHandle,arr,FLOPP_S,_WRITED,@Overlap);
  LastError := GetLastError;
  ShowMessage(' ');

  if not res then
   begin  
    if LastError = ERROR_IO_PENDING then
     while  WaitForSingleObject(Overlap.hEvent,100)=WAIT_TIMEOUT do
       Application.ProcessMessages
                                    else
     ShowMessage(' ');
   end;
  GetOverlappedResult(FileHandle,Overlap,_WRITED,FALSE); 
  ShowMessage(' !   '+IntToStr(_WRITED));  
  CloseHandle(Overlap.hEvent);
  CloseHandle(FileHandle);

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  h:THandle;
begin
  CloseHandle(CreateFile('a:\file.dat',GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0));
end;

procedure EndWrite(dwErrorCode:DWORD; dwNumberOfBytesTransfered:DWORD; lpOverlapped:POverlapped);stdcall;
begin
 ShowMessage(' !   '+IntToStr(dwNumberOfBytesTransfered));
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  FileHandle,DestFileHandle:THandle;
  Overlap: TOverlapped;
  res:BOOL;
  _WRITED,i,LastError:DWORD;
begin
  FillChar(Overlap,SizeOf(Overlap),0);
  for i:=1 to trunc(FLOPP_S/100) do
   arr[i*100]:=ord('Q');
  FileHandle:=CreateFile('a:\file.dat',GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,0);
  if FileHandle=INVALID_HANDLE_VALUE then
   begin
    ShowMessage(' ');
    exit;
   end;
  Overlap.hEvent:=CreateEvent(0,True,False,0);
  
  res:=WriteFileEx(FileHandle,@arr,FLOPP_S,Overlap,@EndWrite);
  LastError := GetLastError;
  ShowMessage(' ');
  while WaitForSingleObjectEx(Overlap.hEvent,1000,True)=WAIT_TIMEOUT do
   Application.ProcessMessages ;

  GetOverlappedResult(FileHandle,Overlap,_WRITED,FALSE); 
  ShowMessage(' !   '+IntToStr(_WRITED));
  CloseHandle(Overlap.hEvent);
  CloseHandle(FileHandle);
  
end;

end.
